public class BirthdayParty extends Throwable {

    int nbOfPeople;
    int nbOfCakes;

    BirthdayParty(int nbOfPeople) {
        this.nbOfPeople = nbOfPeople;
        this.nbOfCakes = 0;
    }

    private void throwParty() throws NotEnoughCake, NotYourBirthday {
        if (!hasEnoughCake())
            throw new NotEnoughCake(nbOfPeople/2 - nbOfCakes);
        eatSomeCake();
        System.out.println("This is an awesome party!");
        eatSomeCake(); // om nom
    }

    private void buyMoreCake(int amount) {
        nbOfCakes += amount;
    }

    private boolean hasEnoughCake() {
        return nbOfCakes >= nbOfPeople/2;
    }

    private void eatSomeCake() {
        this.nbOfCakes--;
    }

    public static void main(String[] args) {

        BirthdayParty party = new BirthdayParty(20);
        try {
            party.throwParty();
        } catch (NotEnoughCake e) {
            System.out.println("We are missing" + e.missingCakes + "cakes :(");
        } catch (NotYourBirthday e) {
            System.out.println("It's not your birthday :(");
        }

    }

}
